local media = LibStub("LibSharedMedia-3.0")

function PWBInfo:BuildGui()
	-- Information frame setup
	InfoFrame = CreateFrame("Frame", nil, UIParent)
	InfoFrame:SetFrameStrata("BACKGROUND")
	InfoFrame:SetPoint("BOTTOMLEFT", self.db.x, self.db.y)
	InfoFrame:SetBackdrop({bgFile = media:Fetch("background", "Blizzard Tooltip"), tile = false})

	-- Information frame movement
	InfoFrame:RegisterForDrag('LeftButton')
	InfoFrame:SetClampedToScreen(true)
	InfoFrame:SetScript("OnDragStart", function(self) PWBInfo:Dragstart(self) end )
	InfoFrame:SetScript('OnDragStop', function(self) PWBInfo:Dragstop(self) end )

	-- Information text

	VengeanceText =	Protwarbar:CreateTextField(InfoFrame, self.db)

	-- VengeanceText = InfoFrame:CreateFontString(nil, 'OVERLAY')
	-- VengeanceText:SetPoint("LEFT", 4, 0);
	-- VengeanceText:SetFont(media:Fetch("font", self.db.font), self.db.fontsize, "OUTLINE")
	-- VengeanceText:SetText(0)

	PWBInfo:UpdateStyling()
	PWBInfo:UpdateVisiblity()
end

function PWBInfo:UpdateStyling()
	Protwarbar:UpdateFrame(InfoFrame, self.db)
	Protwarbar:UpdateTextField(VengeanceText, self.db)
	Protwarbar:UpdateBackdropColor(InfoFrame, self.db, "background")
end

function PWBInfo:UpdateVisiblity()
	if self.db.enabled == true and Protwarbar:IsVisible() then
		InfoFrame:Show()
	else
		InfoFrame:Hide()
	end
end

function PWBInfo:Dragstart(frame)
	if not Protwarbar.db.profile.locked then
		frame:StartMoving()
	end
end

function PWBInfo:Dragstop(frame)
	frame:StopMovingOrSizing()

	self.db.x = InfoFrame:GetLeft()
	self.db.y = InfoFrame:GetBottom()
end