local media = LibStub("LibSharedMedia-3.0")

function PWBLog:BuildGui()
	-- Information frame setup
	-- PWBLogFrame = CreateFrame("Frame", "PWBLogFrame", UIParent)
	-- PWBLogFrame:SetFrameStrata("BACKGROUND")
	-- PWBLogFrame:SetPoint("BOTTOMLEFT", self.db.x, self.db.y)
	-- PWBLogFrame:SetBackdrop({bgFile = media:Fetch("background", "Blizzard Tooltip"), tile = false})

	-- -- Information frame movement
	-- PWBLogFrame:RegisterForDrag('LeftButton')
	-- PWBLogFrame:SetClampedToScreen(true)
	-- PWBLogFrame:SetScript("OnDragStart", function(self) PWBLog:Dragstart(self) end )
	-- PWBLogFrame:SetScript('OnDragStop', function(self) PWBLog:Dragstop(self) end )

	PWBTopFrame = CreateFrame("Frame", "PWBTopFrame", UIParent)
	PWBTopFrame:SetPoint("BOTTOMLEFT", 0, 0)
	PWBTopFrame:SetBackdrop({bgFile = media:Fetch("background", "Blizzard Tooltip"), tile = false})

	PWBTopFrame:RegisterForDrag('LeftButton')
	PWBTopFrame:SetClampedToScreen(true)
	PWBTopFrame:SetScript("OnDragStart", function(self) PWBLog:Dragstart(self) end )
	PWBTopFrame:SetScript('OnDragStop', function(self) PWBLog:Dragstop(self) end )

	PWBTopText = PWBTopFrame:CreateFontString(nil, 'OVERLAY')
	PWBTopText:SetPoint("LEFT", 4, 0);
	PWBTopText:SetFont(media:Fetch("font", self.db.font), self.db.fontsize, "OUTLINE")
	PWBTopText:SetText(0)

	PWBLog:UpdateStyling()
	PWBLog:UpdateVisiblity()
end

function PWBLog:UpdateStyling()
	local style = nil

	if self.db.useDefaults then
		style = Protwarbar.db.profile.default.appearence
	else
		style = self.db
	end

	local scale = Protwarbar.db.profile.default.appearence.scale

	PWBTopFrame:SetWidth(self.db.width * scale)
	PWBTopFrame:SetHeight(self.db.height * scale)
	PWBTopFrame:SetMovable(not Protwarbar.db.profile.locked)
	PWBTopFrame:EnableMouse(not Protwarbar.db.profile.locked)
	PWBTopFrame:SetPoint("BOTTOMLEFT", self.db.x, self.db.y)

	PWBTopText:SetFont(media:Fetch("font", self.db.font), self.db.fontsize, "OUTLINE")

	if Protwarbar.db.profile.locked then
		PWBTopFrame:SetBackdropColor(style.background[1], style.background[2],style.background[3], style.background[4])
	else
		PWBTopFrame:SetBackdropColor(Protwarbar.db.profile.default.appearence.unlockbg[1],
			Protwarbar.db.profile.default.appearence.unlockbg[2],
			Protwarbar.db.profile.default.appearence.unlockbg[3],
			Protwarbar.db.profile.default.appearence.unlockbg[4])
	end

end

function PWBLog:UpdateVisiblity()
	PWBTopFrame:Show()
	if self.db.enabled == true and Protwarbar:IsVisible() then
		PWBTopFrame:Show()
	else
		PWBTopFrame:Hide()
	end
end

function PWBLog:Dragstart(frame)
	if not Protwarbar.db.profile.locked then
		frame:StartMoving()
	end
end

function PWBLog:Dragstop(frame)
	frame:StopMovingOrSizing()

	self.db.x = PWBTopFrame:GetLeft()
	self.db.y = PWBTopFrame:GetBottom()
end